import 'package:aagnia_base_package/SignUpScreenComponent.dart';
import 'package:country_code_picker/country_code_picker.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:flutter/material.dart';

import 'package:toast/toast.dart';
import 'LoginScreen.dart';
import 'OtpScreen.dart';
import 'DashBoardScreen.dart';
import 'package:example/Firebase Classes/sign_in.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:firebase_auth/firebase_auth.dart';

class SignUpScreen extends StatefulWidget {
  static String tag = AppStrings.SIGN_UP_TAG;

  @override
  SignUpScreenState createState() => SignUpScreenState();
}

class SignUpScreenState extends State<SignUpScreen> {
  //controllers
  final phoneNumberController = TextEditingController();
  final emailController = TextEditingController();
  final passwordController = TextEditingController();
  final firstNameController = TextEditingController();
  final lastNameController = TextEditingController();

  //tab bar options
  List<String> tabBarName = [
    AppStrings.SOCIAL,
    AppStrings.MOBILE,
    AppStrings.EMAIL
  ];

  //child variables
  String phoneNumber;
  String countryCode = "+91";
  String phoneNo, verificationId, smsCode;
  bool codeSent = false;
  static String user_name;
  static String user_email;
  static bool user_emailVerified;
  static String user_imageUrl;
  static String user_token;
  static String user_uid;
  static SharedPreferences sharedPreferences;

  //Firebase Auth instance

  final FirebaseAuth __firebaseAuth = FirebaseAuth.instance;

  //formkey
  var _formKey = GlobalKey<FormState>();
  var _phoneGlobalKey = GlobalKey<FormState>();

  //facebook login
 // static final FacebookLogin facebookSignIn = new FacebookLogin();

  CountryCode code;

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    //_onCountryChange(code);
  }

  @override
  void dispose() {
    // Clean up the controller when the widget is removed from the
    // widget tree.
    phoneNumberController.dispose();
    emailController.dispose();
    passwordController.dispose();
    firstNameController.dispose();
    lastNameController.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: SignUpScreenComponent(
        googleSignUp: googleSignUp,
        facebookSignUp: facebookSignUp,
        phoneNumberController: phoneNumberController,
        phoneNumberSignInFunction: phoneNumberSignInFunction,
        globalKey: _formKey,
        phoneGlobalKey: _phoneGlobalKey,
        emailController: emailController,
        passwordController: passwordController,
        firstNameController: firstNameController,
        lastNameController: lastNameController,
        emailPasswordSignInFunction: emailPasswordSignInFunction,
        signInFunction: signInPage,
        tabEnabledName: tabBarName,
        countryCodePicker: _onCountryChange,
      ),
    );
  }

  Future<void> googleSignUp() async {
    signInWithGoogle().then((result) {
      if (result != null) {
        Navigator.of(context).push(
          MaterialPageRoute(
            builder: (context) {
              return DashBoardScreen();
            },
          ),
        );

        user_email = email;
        user_name = name;
        user_emailVerified = emailVerified;
        user_imageUrl = imageUrl;
        user_token = token;
        user_uid = uid;

        /* user_name = sharedPreferences.getString(AppStrings.USER_NAME);
        user_email = sharedPreferences.getString(AppStrings.USER_EMAIL);
        user_imageUrl = sharedPreferences.getString(AppStrings.USER_IMAGE_URL);
        user_token = sharedPreferences.getString(AppStrings.USER_TOKEN);
        user_uid = sharedPreferences.getString(AppStrings.USER_UID);
        user_emailVerified = sharedPreferences.getBool('true');
*/

       /* print("Name=====>" + name);
        print("Name=====>" + email);
        print("Name=====>" + emailVerified.toString());
        print("Name=====>" + imageUrl);
        print("Name=====>" + uid);*/
        Toast.show("Login Success" + name, context);
      } else {
        Toast.show("Login Failed", context);
      }
    }).catchError((onError){
      print("Error====>"+onError.toString());
    });
  }

  Future<void> facebookSignUp() async {
    Toast.show("Facebook Sign in Method Calling", context);
    print("Facebook Login Revoked");
    //facebookLogin();
  }

  Future<void> emailPasswordSignInFunction() async {
    final isValid = _formKey.currentState.validate();
    if (!isValid) {
      return;
    }
    _formKey.currentState.save();
    print("email Password Sign In Function");

    signUp(emailController.text.toString(), passwordController.text.toString());
  }

  Future<void> signUp(String email, String password) async {
    __firebaseAuth
        .createUserWithEmailAndPassword(email: email, password: password)
        .then((result) {
      if (result != null) {
        Navigator.of(context).push(
          MaterialPageRoute(
            builder: (context) {
              return DashBoardScreen();
            },
          ),
        );
        Toast.show("Login Success", context);
      } else {
        Toast.show("Login Failed", context);
      }
    });
  }

  Future<void> phoneNumberSignInFunction() async {
    final isValid = _phoneGlobalKey.currentState.validate();
    if (!isValid) {
      return;
    }
    _phoneGlobalKey.currentState.save();
    phoneNumber = phoneNumberController.text.toString();

    if (phoneNumber.isNotEmpty) {
      if (phoneNumber.length == 10) {
        //verifyPhone(phoneNumber);
        Navigator.pushReplacement(context,
            MaterialPageRoute(builder: (BuildContext context) => OtpScreen()));
      } else {
        print("Phone number to short");
      }
    } else {
      print("Phone Number empty");
    }
  }

  Future<void> signInPage() async {
    Navigator.pushReplacement(context,
        MaterialPageRoute(builder: (BuildContext context) => LoginScreen()));
  }

  Future<void> verifyPhone(String num) async {
    print("Phone Number" + countryCode + num);
    final PhoneCodeAutoRetrievalTimeout autoRetrievalTimeout = (String verId) {
      this.verificationId = verId;
    };

    final PhoneCodeSent smsCodeSent = (String verId, [int forceCodeResend]) {
      this.verificationId = verId;
    };

    final PhoneVerificationCompleted verifiedSuccess =
        (PhoneAuthCredential user) {
      print("verified=====>");
    };

    final PhoneVerificationFailed verifiedFailed =
        (FirebaseAuthException user) {
      print("Failed Login=====>");
    };

    await FirebaseAuth.instance.verifyPhoneNumber(
      phoneNumber: countryCode + " " + num,
      codeAutoRetrievalTimeout: autoRetrievalTimeout,
      codeSent: smsCodeSent,
      timeout: const Duration(seconds: 10),
      verificationCompleted: verifiedSuccess,
      verificationFailed: verifiedFailed,
    );
  }

/*  Future<void> facebookLogin() async {
    final FacebookLoginResult result = await facebookSignIn.logIn(['email']);

    switch (result.status) {
      case FacebookLoginStatus.loggedIn:
        final FacebookAccessToken accessToken = result.accessToken;
        print('''
         Logged in!
         
         Token: ${accessToken.token}
         User id: ${accessToken.userId}
         Expires: ${accessToken.expires}
         Permissions: ${accessToken.permissions}
         Declined permissions: ${accessToken.declinedPermissions}
         ''');
        break;
      case FacebookLoginStatus.cancelledByUser:
        print('Login cancelled by the user.');
        break;
      case FacebookLoginStatus.error:
        print('Something went wrong with the login process.\n'
            'Here\'s the error Facebook gave us: ${result.errorMessage}');
        break;
    }
  }

  Future<void> _logOut() async {
    await facebookSignIn.logOut();
    print('Logged out.');
  }*/

  void _onCountryChange(CountryCode countryCode) {
    this.countryCode = countryCode.toString();
  }
}
